#include <windows.h>
#include <string.h>
#include <malloc.h> // realloc() and _msize()
#include <stdio.h>
#include "procs.h"

// This procedure will add all the protocols to the protocol list
// instead of doing this in "WinMain's" file as a result, only this
// file needs to be edited to add new protocols!
// don't forget to update helpcmds() and setcmds() if you add new protocols 

int initprots(void){
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"POP3");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"SMTP");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"QUAKE3");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"IDENT");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"HTTP");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"FINGER");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"ECHO");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"DISCARD");
	SendMessage(prothandle,CB_ADDSTRING,0,(long)"DAYTIME");

//! others will be echo, ftp?, finger
//! include "Other" in order to reset everything to default?
	return 0;
}


// display general help, help on protocols or commands in output window
int helpcmds(void){
char protocol[MAXPROTLEN];
char command[MAXCOMLEN+1]; 
int cursel;

	cursel=SendMessage(prothandle,CB_GETCURSEL,0,0);
	if(cursel==CB_ERR){ // display general help
		display("Quick Start: Select PROTOCOL first. This will set the correct PORT and TCP/UDP settings.  ");
		display("If you don't do that, you will not see a list of commands and help will not be available to you. ");
		display("FYI, some protocols can use TCP and UDP in this case TCP will be selected since it is a reliable protocol.\r\n");
		return 1;
	}
	cursel=SendMessage(prothandle,CB_GETLBTEXT,cursel,(long)protocol);
	if(cursel==CB_ERR){
		MessageBox(whandle,"Error Getting Protocol Selection!","ERROR",MB_OK);
		return -1;
	}
	cursel=SendMessage(comhandle,CB_GETCURSEL,0,0);
	if(cursel==CB_ERR){ // display help on protocol
//!		display("At this point, you can select any command and HELP will tell you what that command does.");
//############################ PROTOCOL HELP ###########################
		if(strstr(protocol,"SMTP")){
			display("SMTP is Simple Mail Transfer Protocol. It's used to send e-mail.\r\n");
			return 2;
		}
		if(strstr(protocol,"POP3")){
			display("POP3 is Post Office Protocol. It's used to receive e-mail.\r\n");
			return 2;
		}
		if(strstr(protocol,"QUAKE3")){
			// explain what challenge strings are
			display("Quake3 server query commands start with 4 characters  which are not displayed correctly by windows. Do not erase them!\r\n");
			return 2;
		}
		if(strstr(protocol,"IDENT")){
			display("Ident server identifies the ownership of a connection.\r\n");
			return 2;
		}
		if(strstr(protocol,"HTTP")){
			display("Hyper Text Transfer Protocol.\r\n");
			return 2;
		}
		if(strstr(protocol,"FINGER")){
			display("Finger protocol returns a list of usernames or information on a user.\r\n");
			return 2;
		}
		if(strstr(protocol,"ECHO")){
			display("Echo will echo the string back.\r\n");
			display("It can be used to find out if UDP is available or blocked by a firewall for example.\r\n");
			return 2;
		}
		if(strstr(protocol,"DISCARD")){
			display("DISCARD will discard any command sent to it.\r\n");
			return 2;
		}
		if(strstr(protocol,"DAYTIME")){
			display("DayTime will show you the correct time on the remote host.\r\n");
			display("This can be used for example to find out which time zone the host is located and therefore estimate it's location.\r\n");
			display("There are no commands available.\r\n");
			return 2;
		}
//########################### END OF PROTOCOL HELP #####################
		display("Help on this protocol is NOT available.");
		return -2;
	}
	cursel=SendMessage(comhandle,CB_GETLBTEXT,cursel,(long)command);
	if(cursel==CB_ERR){
		MessageBox(whandle,"Error Getting Command Selection!","ERROR",MB_OK);
		return 1;
	}
// Use strstr (user cann add to commands) and some comands have extra chars
// strstr is case sensitive !!!
//############################ COMMANDS HELP ##########################
	if(strstr(protocol,"SMTP")){
		if(strstr(command,"HELP")){
			display(command);
			return 3;
		}
	}
	if(strstr(protocol,"POP3")){
		if(strstr(command,"user")){
			display(command);
			return 3;
		}
	}
	if(strstr(protocol,"Quake3")){ //first 4 chars are garbage.
		if(strstr(command,"getstatus")){
			display((command+4));
			return 3;
		}
		if(strstr(command,"getinfo")){
			display((command+4));
			return 3;
		}
		if(strstr(command,"getchallenge")){
			display((command+4));
			return 3;
		}
		if(strstr(command,"connect")){
			display((command+4));
			return 3;
		}
		if(strstr(command,"rcon")){
			display((command+4));
			return 3;
		}
	}
	if(strstr(protocol,"IDENT")){
		if(strstr(command,"local port")){
			display("If you supply the port #s correctly, this command will return the USER id of the owner of the socket on the remote computer.  ");
			display("You can use NETSTAT to find out the port #s.\r\n");
			return 3;
		}
	}
	if(strstr(protocol,"HTTP")){
		if(strstr(command,"GET")){
			display("GET </path/filename> will get a file.\r\n");
			return 3;
		}
	}
	if(strstr(protocol,"FINGER")){
		if(strstr(command,"<username>")){
			display("This command will return information on a particular user name.\r\n");
			return 3;
		}
	}
	if(strstr(protocol,"FINGER")){
		if(strstr(command,"<empty string>")){
			display("This command will return a list of users logged in.\r\n");
			return 3;
		}
	}
	if(strstr(protocol,"ECHO")){
		display("Anything that you sent will be sent back to you (like ping).\r\n");
		return 3;
	}
	if(strstr(protocol,"DISCARD")){
		display("Anything that you sent will be lost.\r\n");
		return 3;
	}

//########################### END OF COMMANDS HELP #####################
	display("Help on this command is not available.\r\n");
	return -3;
}


// Set commands in Commands combo box acording to protocol selection
// set port # here too, according to protocol selection
int setcmds(char * protocol){
LRESULT ok;
//############################ COMMANDS ASSIGNMENT #####################
	if(strstr(protocol,"SMTP")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"SMTP Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"25");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);

		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"HELO");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"RSET");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"EXPN");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"EHLO");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"VERB");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"NOOP");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"MAIL FROM: <sender>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"QUIT");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"RCPT TO: <recipient>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"HELP");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"DATA");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"VRFY");
	}
	if(strstr(protocol,"POP3")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"POP3 Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"110");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);

		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"USER <name>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"PASS <password>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"QUIT");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"STAT");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"LIST [message #]");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"RETR <message #>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"DELE <message #>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"NOOP");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"RSET");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"TOP <messsage #> <# of lines>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"UIDL [message #]");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"APOP <name> <digest>");

	}
	if(strstr(protocol,"QUAKE3")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"Quake3 Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"27960");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,1,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);

		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"\xff\xff\xff\xffgetstatus");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"\xff\xff\xff\xffgetinfo");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"\xff\xff\xff\xffgetchallenge");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"\xff\xff\xff\xff connect");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE)
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"\xff\xff\xff\xffrcon");
	}
	if(strstr(protocol,"IDENT")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"IDENT Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"113");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"<remote port>,<local port>");
	}
	if(strstr(protocol,"HTTP")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"HTTP Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"80");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"GET");
	}

	if(strstr(protocol,"FINGER")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"FINGER Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"79");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"<username>");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"<empty string>");
	}
	if(strstr(protocol,"ECHO")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"ECHO Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"7");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"blah...");
	}
	if(strstr(protocol,"DISCARD")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"Discard Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"9");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // add new commands
			ok=SendMessage(comhandle,CB_ADDSTRING,0,(long)"blah...");
	}
	if(strstr(protocol,"DAYTIME")){
		ok=SendMessage(comlablehandle,WM_SETTEXT,0,(long)"Daytime Commands");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set port #
			ok=SendMessage(porthandle,WM_SETTEXT,0,(long)"13");
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // set TCP or UDP protocol
			ok=SendMessage(tcpudphandle,CB_SETCURSEL,0,0); // 0=TCP 1=UDP
		if(ok!=CB_ERR && ok!=CB_ERRSPACE) // clear existing commands
			ok=SendMessage(comhandle,CB_RESETCONTENT,0,0);
	}
//###################### END OF COMMANDS ASSIGNMENT ##################
	if(ok!=CB_ERR && ok!=CB_ERRSPACE)return 0;
	return 1;
}


// Do not change anything after this line when adding a new protocol.
char * listport(int portnum){
	switch(portnum){
	case 7: return "(echo)";
	case 9: return "(discard)";
	case 11: return "(systat)";
	case 13: return "(daytime)";
	case 15: return "(netstat)";
	case 19: return "(chargen)";
	case 20: return "(ftp-data)";
	case 21: return "(ftp)";
	case 23: return "(telnet)";
	case 25: return "(smtp)";
	case 37: return "(timeserver)";
	case 42: return "(nameserver)";
	case 43: return "(whois)";
	case 53: return "(domain)";
	case 67: return "(bootp?)";
	case 68: return "(bootp?)";
	case 101: return "(hostnames)";
	case 110: return "(pop3)";
	case 111: return "(sunrpc)";
	case 113: return "(ident)";
//	case : return "()";
	default: return "";
	}
}


int display(char * str){
int oldlen;
	oldlen=GetWindowTextLength(outhandle);
	SendMessage(outhandle,EM_SETSEL,(WPARAM)oldlen,(LPARAM)oldlen);
	SendMessage(outhandle,EM_REPLACESEL,(WPARAM)FALSE,(LPARAM)str);
	return 0;
}

/*
// Append text in the output window
int display(char * str){
char * buff;
int oldlen;
	oldlen=GetWindowTextLength(outhandle);
	buff= (char*) malloc(oldlen+strlen(str)+XTRA_MSG);
	GetWindowText(outhandle,buff,oldlen+XTRA_MSG);
	strcpy((char*)(buff+oldlen),str);
	SetWindowText(outhandle,buff);
	SendMessage(outhandle,EM_LINESCROLL,0,SendMessage(outhandle,EM_GETLINECOUNT,0,0));
	return 0;
}
*/
/*
// this works only under NT and Win 16. EM_GETHANDLE doesn't work in 95
int display(char * str){
char * buffhand;
int oldsize;
int oldstrsize;
	buffhand= (char*) SendMessage(outhandle,EM_GETHANDLE,0,0);
	if((int)(buffhand)<1){
		MessageBox(whandle,"Error getting edit window handle","ERROR",MB_OK);
		return 1;
	}
	oldsize=_msize(buffhand);
	oldstrsize=GetWindowTextLength(outhandle);
//	if(oldsize>2) oldstrsize=strlen(buffhand);

	if( (oldstrsize+strlen(str)+DELTA_MSG) > (unsigned) oldsize ){
		buffhand=(char*)realloc(buffhand,oldstrsize+strlen(str)+XTRA_MSG);
		if(!buffhand){
			MessageBox(whandle,"Error allocating memory.", "ERROR",MB_OK);
			return 1;
		}
		oldsize = -1;
	}
	buffhand[oldstrsize] = '\n'; // add new line for clearety
	// '\0' (NULL) is not there any more.
	strcpy((buffhand+oldstrsize+1),str);
	if(oldsize == -1) // New Handle
		SendMessage(outhandle,EM_SETHANDLE,(WPARAM)buffhand,0);
	SendMessage(outhandle,EM_SETMODIFY,(WPARAM) TRUE,0);
	return 0;
}
*/
