#ifndef PROCS_H
#define PROCS_H

#include <windows.h>

// IDs of child controls used to CreateWindow and in window procedure
#define IPID 101
#define PORTID 102
#define CONID 103 // button
#define PROTID 104
#define COMID 105
#define HELPID 106 // button
#define SENDID 107	//button
#define OUTID 108
#define CLRID 109
#define TCPUDPID 110
#define SCANID 111 // button

// used in controls creation (SendMessage) and buffer allocation
#define MAXIPLEN 100 // maximum length of the IP string
#define MAXPORTLEN 10 // pORt
#define MAXPROTLEN 80 // pROtocol
#define MAXCOMLEN 200 // command string


// used in display()
#define XTRA_MSG 4000 // new free space in text buffer

// used in wproc() in NetPlorere to send NETwork related messages
#define WM_NET			(WM_USER+1) // user defined messages
#define WM_RESETNET		WM_USER+2


// Globals declared(instanciated) in NetPlorer.cpp

extern HINSTANCE hInst;
extern HWND whandle;
extern HWND iplablehandle;
extern HWND iphandle;
extern HWND porthandle;
extern HWND tcpudphandle;

extern HWND conhandle;
extern HWND protlable; // ?? error ?? extra ??
extern HWND protlablehandle;
extern HWND prothandle;
extern HWND comlablehandle;
extern HWND comhandle;
extern HWND helphandle;
extern HWND sendhandle;
extern HWND outhandle;
extern HWND clrhandle;
extern HWND scanhandle;

// all 4 of these are implemented in procs.cpp
// change first 3 functions to add new protocols
int initprots(void);
int helpcmds(void);
int setcmds(char * protocol);
int display(char * str);
char* listport(int portnum);

#endif