// sock.cpp: implementation of the sock class.
#include "procs.h"
#include "sock.h"


int sock::conn(char* addr, int port){
hostent* ipent;
SOCKADDR_IN ip;
 	if(tcptrue) s=socket(AF_INET,SOCK_STREAM,0);
	else s=socket(AF_INET,SOCK_DGRAM,0);
	if(s==INVALID_SOCKET){
		MessageBox(msghand,"Error creating socket.","Connect ERROR",MB_OK);
		return 1;
	}
	ipent=gethostbyname(addr);
	if(!ipent){
		MessageBox(msghand,"Can't gethostbyname()","Connect ERROR",MB_OK);
		return 2;
	}
	ip.sin_family=AF_INET;
	ip.sin_port=htons(port);
	ip.sin_addr.s_addr=*((unsigned long *)ipent->h_addr); // h_addr is macro for h_addr_list[0]
	if(ip.sin_addr.s_addr == INADDR_NONE){
		MessageBox(msghand,"gethostbyname() returned INADDR_NONE","Connect ERROR",MB_OK);
		return 3;
	}
	if(WSAAsyncSelect(s,msghand,WM_NET,FD_READ|FD_CONNECT|FD_CLOSE) ){
		MessageBox(msghand,"WSAAsyncSelect() failed.","Connect ERROR",MB_OK);
		return 5;
	}
	connect(s,(SOCKADDR*)&ip, sizeof(ip) ); // will return error. Ignore
	return 0;
}


sock::sock(BOOL tcp, HWND handler){ // if tcp is FALSE, use UDP
	msghand=handler;
	tcptrue=tcp;
	if(WSAStartup(0x0202,&wsd)) MessageBox(msghand,"Error upon WSAStartup()","Winsock ERROR",MB_OK);
}


sock::~sock(){
	disconn();
	WSACleanup(); // unloads the dll
}


int sock::disconn(void){
//	shutdown(s,SD_BOTH);
	closesocket(s);
	s=INVALID_SOCKET; // Connect checks it
	return 0;
}


int sock::write(char* buff, int size){
	if(s==INVALID_SOCKET){
		MessageBox(msghand,"Socket not initialized - Can't write.","ERROR",MB_OK);
		return -1;
	}
	return send(s,buff,size,0);
}


int sock::read(char* buff, int size){
	if(s==INVALID_SOCKET){
		MessageBox(msghand,"Socket not initialized - Can't read.","ERROR",MB_OK);
		return -1;
	}
	return recv(s,buff,size,0);
}